// -*-c++-*-

#ifndef _RCC_INIT_MSG_H_
#define _RCC_INIT_MSG_H_

#include "rccplaymode.h"
#include <iostream.h>
#include "rccgarbage.h"
#include "types.h"
#include "rccsditem.h"

class RCC_InitMsg : public RCC_GCable, public RCC_SD_Item
{
public:
  RCC_InitMsg ( const Side& s, const int& un, const RCC_PlayMode& pm ) : side_ ( s ), unum ( un ), play_mode ( pm ) {}
  RCC_InitMsg ( const Side& s, const RCC_PlayMode& pm ) : side_ ( s ), unum ( -1 ), play_mode ( pm ) {}

  ~RCC_InitMsg () {}

  RCC_SD_Item* copy () const { return ( RCC_SD_Item* ) new RCC_InitMsg ( *this ); }

  friend ostream& operator<< ( ostream& o, const RCC_InitMsg& m )
  {
    return m.print ( o );
  }
  
  ostream& print ( ostream& o ) const 
  {
    if ( unum == -1 )
      o << "(recconect " << ( side_ == LEFT ? "l " : "r " );
    else
      o << "(init " << ( side_ == LEFT ? "l " : "r " ) << unum << " ";
		
    o << play_mode.stadMode ( side_ ) << ")";
    return o;
  }

  ostream& print ( ostream& o, const Side& ) const { return print ( o ); } 
  
  Side side () const { return side_; }
  int uNum () const { return unum; }

protected:
  Side		side_;
  int		unum;
  RCC_PlayMode 	play_mode;
};

#endif
