// -*-c++-*-
#ifndef _RCC_PARSER_H_
#define _RCC_PARSER_H_

#include "types.h"
#include "rccsensordata.h"
#include <string.h>
#include <config.h>

#ifdef RCC_COMPARE
int compare ( const char* in, const char* out, int length )
{
  if ( strncmp ( in, out, length ) == 0 )
    {
      return 0;
    }
  else
    {
      if ( in [ 0 ] == out [ 0 ] )
	{
	  in++;
	  out++;
	  return compare ( in, out, length - 1 );
	}
      else if ( strncmp ( in, "-0 ", 3 ) == 0 ||
		strncmp ( in, "-0)", 3 ) == 0 )
	{
	  in++;
	  in++;
	  out++;
	  return compare ( in, out, length - 1 );	  
	}
      else if ( strncmp ( out, "-0 ", 3 ) == 0 ||
		strncmp ( out, "-0)", 3 ) == 0 )
	{
	  in++;
	  out++;
	  out++;
	  return compare ( in, out, length - 1 );	  
	}
      else
	{
	  cout << PACKAGE << "-" << VERSION << ": " 
	       << __FILE__ << ": " << __LINE__ 
	       << ": Buffer does not match input\n";
	  cout << " in>" << in << "<\n";
	  cout << "out>" << out << "<\n";
	  return -1;
	}
    }
}
#endif

struct rccparam_t
{
  // intput parameters
  const string& 	tn;
  const Side&   	side;

  // output parameters
  RCC_SensorData& 	sd;

  // local paramters
  RCC_GarbageCollector 	gc;
};


extern "C" {
  int RCC_Parse ( const char* s, const string& team_name, const Side& side, RCC_SensorData& buffer );
}

class RCC_Parser
{
public:
  RCC_Parser () : team_name ( "" ), side_ ( NEUTRAL ) {}
  
  string teamName ( const string& tn ) { return team_name = tn; }
  Side side ( const Side& s ) { return side_ = s; }

  int parse ( const char* str, RCC_SensorData& buffer )
  {
#ifdef RCC_COMPARE
    if ( RCC_Parse ( str, team_name, side_, buffer ) == 0 )
      {
	char out [ MaxMesg ];
	strstream stream ( out, MaxMesg );
	
	buffer.print ( stream, side_ ) << ends;
	
	if ( compare ( str, out, MaxMesg ) == 0 )
	  return 0;
	else
	  {
	    return -1;
	    cout << " input>" << str << "<\n";
	    cout << "output>" << out << "<\n";
	  }
      }
    else return -1;
#else
    return RCC_Parse ( str, team_name, side_, buffer );
#endif
  }

protected:
  string team_name;
  Side side_;
};	

#endif
