// -*-c++-*-

#ifndef _RCC_PLAYER_PARAM_H_
#define _RCC_PLAYER_PARAM_H_

#include <iostream.h>
#include "rccgarbage.h"
#include "rccsditem.h"

class RCC_PlayerParam : public RCC_GCable, public RCC_SD_Item
{
public:
    RCC_PlayerParam (const int& player_types,
		 const int& subs_max,
		 const int& pt_max,
  
		 const double& player_speed_max_delta_min,
		 const double& player_speed_max_delta_max,
		 const double& stamina_inc_max_delta_factor,
    
		 const double& player_decay_delta_min,
		 const double& player_decay_delta_max,
		 const double& inertia_moment_delta_factor,

		 const double& dash_power_rate_delta_min,
		 const double& dash_power_rate_delta_max,
		 const double& player_size_delta_factor,

		 const double& kickable_margin_delta_min,
		 const double& kickable_margin_delta_max,
		 const double& kick_rand_delta_factor,

		 const double& extra_stamina_delta_min,
		 const double& extra_stamina_delta_max,
		 const double& effort_max_delta_factor,
		 const double& effort_min_delta_factor );

    ~RCC_PlayerParam () {}
   
  friend ostream& operator<< (ostream& o, const RCC_PlayerParam& sp)
  {
    return sp.print ( o );
  }

  ostream& print ( ostream& o ) const;
  ostream& print ( ostream& o, const Side& ) const { return print ( o ); } 

  RCC_SD_Item* copy () const { return ( RCC_SD_Item* ) new RCC_PlayerParam ( *this ); }

private:
    int player_types;
    int subs_max;
    int pt_max;
  
    double player_speed_max_delta_min;
    double player_speed_max_delta_max;
    double stamina_inc_max_delta_factor;
    
    double player_decay_delta_min;
    double player_decay_delta_max;
    double inertia_moment_delta_factor;

    double dash_power_rate_delta_min;
    double dash_power_rate_delta_max;
    double player_size_delta_factor;

    double kickable_margin_delta_min;
    double kickable_margin_delta_max;
    double kick_rand_delta_factor;

    double extra_stamina_delta_min;
    double extra_stamina_delta_max;
    double effort_max_delta_factor;
    double effort_min_delta_factor;
};


#endif
