// -*-c++-*-

#ifndef _RCC_PLAYER_TYPE_H_
#define _RCC_PLAYER_TYPE_H_

#include <iostream.h>
#include "rccgarbage.h"
#include "rccsditem.h"

class RCC_PlayerType : public RCC_GCable, public RCC_SD_Item
{
public:
  static const int UNKNOWN_ID;

  RCC_PlayerType ( const int& id,
		   const double& player_speed_max,
		   const double& stamina_inc_max,
		   const double& player_decay,
		   const double& inertia_moment,
		   const double& dash_power_rate,
		   const double& player_size,
		   const double& kickable_margin,
		   const double& kick_rand,
		   const double& extra_stamina,
		   const double& effort_max,
		   const double& effort_min );

  ~RCC_PlayerType () {}
   
  friend ostream& operator<< (ostream& o, const RCC_PlayerType& sp)
  {
    return sp.print ( o );
  }

  ostream& print ( ostream& o ) const;
  ostream& print ( ostream& o, const Side& ) const { return print ( o ); } 

  RCC_SD_Item* copy () const { return ( RCC_SD_Item* ) new RCC_PlayerType ( *this ); }

private:
  int id;
  double player_speed_max;
  double stamina_inc_max;
  double player_decay;
  double inertia_moment;
  double dash_power_rate;
  double player_size;
  double kickable_margin;
  double kick_rand;
  double extra_stamina;
  double effort_max;
  double effort_min;
};


#endif
