// -*-c++-*-

#ifndef _RCC_SENSOR_DATA_H_
#define _RCC_SENSOR_DATA_H_

#include <vector>

#include "rccsencebody.h"
#include "rccserverparam.h"
#include "rccplayerparam.h"
#include "rccplayertype.h"
#include "rccobjectpool.h"
#include "rccinitmsg.h"
#include "rccaudio.h"
#include "rccsubstitution.h"
#include "rccgarbage.h"
#include "rccsditem.h"
#include "rccscore.h"

class RCC_SensorData : public RCC_GCable
{
public:
  RCC_SensorData () : element ( NULL ) {}
  RCC_SensorData ( const RCC_SD_Item& i ) : element ( i.copy () ) {}

  ~RCC_SensorData () 
  {
    clear ();
  }

  friend ostream& operator<< (ostream& o, const RCC_SensorData& sd) { return sd.print ( o ); } 
  ostream& print ( ostream& o ) const
  { 
    return element->print ( o ); 
  }

  ostream& print ( ostream& o, const Side& s ) const
  { 
    return element->print ( o, s ); 
  }

  const RCC_SensorData& operator= ( const RCC_SensorData& sd )
  {
    clear ();
    element = sd.element->copy ();
    return *this;
  }

  const RCC_SD_Item* item () const { return element; }
 
private:
  RCC_SD_Item* element;
    
  const RCC_SensorData& clear ()
  {
    delete element;
    element = NULL;
    return *this;
  }
	
};

#endif
