// -*-c++-*-

#ifndef _RCC_SUBSTITUTION_H_
#define _RCC_SUBSTITUTION_H_

#include "rccgarbage.h"
#include "rccsditem.h"
#include "rccside.h"
#include "rccplayertype.h"

class RCC_Substitution : public RCC_GCable, public RCC_SD_Item
{
public:
  RCC_Substitution ( const int& u ) 
    : unum ( u ), 
    side_ ( RCC_Side::Opp ), 
    type_ ( RCC_PlayerType::UNKNOWN_ID )
  {}
  RCC_Substitution ( const int& u, const int& t ) 
    : unum ( u ), 
    side_ ( RCC_Side::Our ), 
    type_ ( t )
  {}

  ~RCC_Substitution () {}

  virtual ostream& print ( ostream& o ) const
  { 
    o << "(change_player_type " << unum;
    if ( type_ != RCC_PlayerType::UNKNOWN_ID )
      o << " " << type_;
    return o << ")";
  }
  ostream& print ( ostream& o, const Side& ) const { return print ( o ); } 
  
  virtual RCC_SD_Item* copy () const { return ( RCC_SD_Item* ) new RCC_Substitution ( *this ); }

  int uNum () const { return unum; }
  RCC_Side side () const { return side_; }
  int type () const { return type_; }

protected:
  int 		unum;
  RCC_Side	side_;
  int		type_;
};

#endif
