#include "rccaudio.h"

RCC_Audio::~RCC_Audio () {}


RCC_RefAudio::~RCC_RefAudio () {}

ostream& RCC_RefAudio::print ( ostream& o ) const 
{
  o << "(hear " << time_ << " referee " 
    << play_mode << ")";

  return o;
}


RCC_SelfAudio::~RCC_SelfAudio () {}

ostream& RCC_SelfAudio::print ( ostream& o ) const 
{
  o << "(hear " << time_ << " self "
    << msg_ << ")";

  return o;
}


RCC_PlayerAudio::~RCC_PlayerAudio () {}

ostream& RCC_PlayerAudio::print ( ostream& o ) const 
{
  o << "(hear " << time_ << " " << dir_ << " "
    << msg_ << ")";

  return o;
}

RCC_CoachAudio::~RCC_CoachAudio () 
{
  delete msg_p;
  msg_p = NULL;
}

ostream& RCC_CoachAudio::print ( ostream& o ) const 
{
  o << "(hear " << time_ << " " << side_ << " " << time_sent << " ";
  msg_p->print ( o );
  o << ")";

  return o;
}

ostream& RCC_CoachAudio::print ( ostream& o, const Side& team_side ) const 
{
  o << "(hear " << time_ << " ";

  if ( side_.stadMode ( team_side ) == LEFT )
    o << "online_coach_left";
  else if ( side_.stadMode ( team_side ) == RIGHT )
    o << "online_coach_left";
  else
    o << "coach";

  o << " " << time_sent << " ";
  msg_p->print ( o );
  o << ")";

  return o;
}

