/* -*- Mode: C++ -*- */
/*
 *Copyright:

    Copyright (C) 2001 RoboCup Soccer Server Maintainance Group.
    	Patrick Riley, Tom Howard, Itsuki Noda,	Mikhail Prokopenko, Jan Wendler 

    This file is part of SoccerServer.

    SoccerServer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

#include <iostream.h>
#include <stdio.h>
#include "rcccoachmsg.h"

/******** Meta Message ********************/

ostream& RCC_CoachMetaMsg::print ( ostream& out ) const
{
  out << "(meta " << tokens_ << ")";
  return out;
}

ostream& RCC_CoachMetaMsg::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header << "Meta" << endl;
  tokens_.printPretty ( out, line_header + " - " );
  return out;
} 

/******** Freeform Message ********************/


ostream& RCC_CoachFreeformMsg::print ( ostream& out ) const
{
  out << "(freeform \"" << str_ << "\")";
  return out;
}

ostream& RCC_CoachFreeformMsg::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header << "Freeform" << endl;
  out << line_header << "  " << "\"" << str_ << "\"" << endl;
  return out;
}

/******** Info Message ********************/

ostream& RCC_CoachInfoMsg::print ( ostream& out ) const
{
  out << "(info " << tokens_ << ")";
  return out;
}

ostream& RCC_CoachInfoMsg::printPretty ( ostream& out, const string& line_header) const
{
  out << line_header << "Info" << endl;
  tokens_.printPretty ( out, line_header + " - ");
  return out;
}

/******** Advice Message ********************/
  
ostream& RCC_CoachAdviceMsg::print ( ostream& out ) const
{
  out << "(advice " << tokens_ << ")";
  return out;
}

ostream& RCC_CoachAdviceMsg::printPretty ( ostream& out, const string& line_header) const
{
  out << line_header << "Advice" << endl;
  tokens_.printPretty ( out, line_header + " - ");
  return out;
}

/******** Define Message ********************/
  
ostream& RCC_CoachDefineMsg::print ( ostream& out ) const
{
  out << "(define " << tokens_ << ")";
  return out;
}

ostream& RCC_CoachDefineMsg::printPretty ( ostream& out, const string& line_header) const
{
  out << line_header << "Define" << endl;
  tokens_.printPretty ( out, line_header + " - ");
  return out;
}
