#include "rcccond.h"

ostream& RCC_CondPlayerPosition::print ( ostream& out ) const
{
  out << "(ppos"
      << " " << side_
      << " " << players
      << " " << min_
      << " " << max_
      << " " << *reg_p
      << ")";
  return out;
}

ostream& RCC_CondPlayerPosition::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header
      << "are " << min_ << "-" << max_ << " " 
      << side_ << " "
      << players << " "
      << "in:" << endl;
  reg_p->printPretty ( out, line_header + " " );
  return out;
}

ostream& RCC_CondBallOwner::print ( ostream& out ) const
{
  out << "(bowner"
      << " " << side_ 
      << " " << players
      << ")";  
  return out;
}

ostream& RCC_CondBallOwner::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header
      << "is ball controlled by someone in " 
      << side_ << " "
      << players << endl;
  return out;
}

ostream& RCC_CondAnd::print ( ostream& out ) const
{
  out << "(and";
  for ( RCC_Condition::container::const_iterator i = conds_.begin (); i != conds_.end (); i++ ) 
    out << " " << **i;
  out << ")";
  return out;
}

ostream& RCC_CondAnd::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header << "and" << endl;
  for ( RCC_Condition::container::const_iterator i = conds_.begin (); i != conds_.end (); i++) 
    ( *i )->printPretty ( out, line_header + " +" );
  return out;
}

bool RCC_CondAnd::eval () const
{
  for ( RCC_Condition::container::const_iterator i = conds_.begin(); i != conds_.end(); i++ ) 
    {
      if ( !(**i) )
	return false;
    }
  return true;
}


ostream& RCC_CondOr::print ( ostream& out ) const
{
  out << "(or";
  for ( RCC_Condition::container::const_iterator i = conds_.begin (); i != conds_.end (); i++ ) 
    out << " " << **i;
  out << ")";
  return out;
}

ostream& RCC_CondOr::printPretty ( ostream& out, const string& line_header ) const
{
  out << line_header << "or" << endl;
  for ( RCC_Condition::container::const_iterator i = conds_.begin (); i != conds_.end (); i++) 
    ( *i )->printPretty ( out, line_header + " +" );
  return out;
}

bool RCC_CondOr::eval () const
{
  for ( RCC_Condition::container::const_iterator i = conds_.begin(); i != conds_.end(); i++ ) 
    {
      if ( **i )
	return true;
    }
  return false;
}


