#include "rccgarbage.h"

RCC_GCable::RCC_GCable ()
{
}

RCC_GCable::~RCC_GCable ()
{
}

RCC_GCElement::~RCC_GCElement ()
{
}

//===============================================
//
//  RCC_GCElement_GCable
//
//===============================================

RCC_GCElement_GCable::~RCC_GCElement_GCable ()
{
}
 
void RCC_GCElement_GCable::delElem ()
{
  delete ptr;
  ptr = NULL;
}

const void* RCC_GCElement_GCable::itemPtr () const
{
  return (void*) ptr;
}

//===============================================
//
//  RCC_GCElement_DoubleArr
//
//===============================================

RCC_GCElement_DoubleArr::~RCC_GCElement_DoubleArr ()
{
}

void RCC_GCElement_DoubleArr::delElem ()
{
  delete[] ptr;
  ptr = NULL;
}

const void* RCC_GCElement_DoubleArr::itemPtr () const
{
  return (void*) ptr;
}

//===============================================
//
//  RCC_GarbageCollector
//
//===============================================


void RCC_GarbageCollector::delAll () 
{
  list< RCC_GCElement* >::iterator elem_iter;
  for (elem_iter = elem_list.begin(); elem_iter != elem_list.end(); elem_iter++) 
    {
     (*elem_iter)->delElem ();
     delete *elem_iter;
    }
  elem_list.clear ();
}

bool RCC_GarbageCollector::remove ( const RCC_GCElement& elem )
{
  list< RCC_GCElement* >::iterator elem_iter;
  for (elem_iter = elem_list.begin(); elem_iter != elem_list.end(); elem_iter++) 
    {
      if ( **elem_iter == elem )
	{
	  elem_list.erase ( elem_iter );
	  delete *elem_iter;
	  return true;
	}
    }
  return false;
}

bool RCC_GarbageCollector::remDel ( const RCC_GCElement& elem )
{
  list< RCC_GCElement* >::iterator elem_iter;
  for (elem_iter = elem_list.begin(); elem_iter != elem_list.end(); elem_iter++) 
    {
      if ( **elem_iter == elem )
	{
	  elem_list.erase ( elem_iter );
	  (*elem_iter)->delElem ();
	  delete *elem_iter;
	  return true;
	}
    }
  return false;
}

