/* -*-bison-*- */
%{

#include <stdio.h>
#include <iostream.h>
#include "rccparser.h"
#include "param.h"

/* C declarations */
#define YYPARSE_PARAM param

#define YYLEX_PARAM param

#define TN ( ( ( rccparam_t* ) param )->tn )
#define SD ( ( ( rccparam_t* ) param )->sd )
#define GC ( ( ( rccparam_t* ) param )->gc )

#define YYERROR_VERBOSE

void yyerror ( char* s );
int yylex ( void* lvalp, void* side );

%}

/* Bison declarations */
%pure_parser

%union {
			bool                        bval;
			int         	        ival;                    
			double			rval;
			double*			rval_arr;
			char			str [ MaxMesg ];
			RCC_ViewMode::quality_t		view_qual;
			RCC_ViewMode::width_t		view_wid;
			RCC_Angle*			angle_p;
			RCC_Vector2d*			vector2d_p;
			RCC_ViewMode* 			view_mode_p;
			RCC_SenceBody* 			sence_body_p;
			RCC_ServerParam*		server_param_p;
			RCC_PlayerParam*		player_param_p;
			RCC_PlayerType*			player_type_p;
			RCC_Object::location_t	location;
			RCC_Line*			line_p;
			RCC_Flag*			flag_p;
			RCC_Ball*			ball_p;
			RCC_PlayerName*			player_name_p;
			RCC_Player*			player_p;
			RCC_Object*			object_p;
			RCC_ObjectPool*			object_pool_p;
			RCC_PlayMode*	playmode_p;
			RCC_InitMsg*			init_msg_p;
			Side	side;
			RCC_Side*	side_p;
			RCC_RefAudio*			ref_audio_p;
			RCC_SelfAudio*			self_audio_p;
			RCC_PlayerAudio*		player_audio_p;
			RCC_CoachAudio*			coach_audio_p;
			RCC_CoachStdMsg*     		coach_std_msg_p;
			RCC_CoachMetaToken*   		coach_meta_token_p;
			RCC_CoachMetaToken_List* 	coach_meta_token_list_p;
			RCC_CoachDefineToken* 		coach_define_token_p;
			RCC_CoachDefineToken_List*	coach_define_token_list_p;
			RCC_Action* 			action_p;
			RCC_Directive* 			directive_p;
			RCC_DirList*	 		dir_list_p;
			RCC_Condition* 			condition_p;
			RCC_CondList* 			cond_list_p;
			RCC_CoachInfoToken* 		coach_info_token_p;
			RCC_CoachInfoToken_List*	coach_info_token_list_p;
			RCC_Region*   			region_p;
			RCC_RegPoint* 			reg_point_p;
			RCC_RegUnion*			reg_union_p;
			RCC_UnumSet*   			unum_set_p;
			RCC_BallMoveSet*		ball_move_set_p;
			RCC_BallMoveSet::RCC_BallMove_t     ball_move;
			RCC_Score* score_p;
			RCC_Substitution* sub_p;
};


%token 	<ival> 		ERROR

%token 	<ival> 		LP
%token 	<ival> 		RP

%token 	<ival> 		IVAL
%token 	<rval>		RVAL
%type 	<rval>		VAL
%token	<str>		QSTR

%token 	<ival> 		CHG_VIEW_KW
%token 	<ival> 		MOVE_KW
%token 	<ival> 		CATCH_KW
%token 	<ival> 		TURN_NECK_KW
%token 	<ival> 		SAY_KW
%token 	<ival> 		TURN_KW
%token 	<ival> 		DASH_KW
%token 	<ival> 		KICK_KW
%token 	<ival>		HIGH_KW
%token	<ival>		LOW_KW
%token	<ival>		NARROW_KW
%token	<ival>		NORMAL_KW
%token	<ival>		WIDE_KW
%token 	<ival>		VIEW_MODE_KW
%token 	<ival>		STAMINA_KW
%token	<ival>		HEAD_ANGLE_KW
%token	<ival>		SPEED_KW

%token 	<ival> 		SENSE_BODY_KW
%token	<ival>		SERVER_PARAM_KW
%token	<ival>		PLAYER_PARAM_KW
%token	<ival>		PLAYER_TYPE_KW

%token 	<ival>		T_KW 
%token 	<ival>		B_KW 
%token 	<ival>		L_KW
%token 	<ival>		R_KW
%token 	<ival>		F_KW
%token	<ival>		C_KW
%token	<ival>		P_KW
%token	<ival>		G_KW
%token	<ival>		D_KW
%token	<ival>		S_KW

%token	<ival>		GOALIE_KW

%token	<ival>		SEE_KW

%token	<playmode_p>	PLAY_MODE_KW

%token	<ival>	BEFORE_KICK_OFF_KW
%token	<ival>	TIME_OVER_KW
%token	<ival>	PLAY_ON_KW
%token	<ival>	KICK_OFF_L_KW
%token	<ival>	KICK_OFF_R_KW
%token	<ival>	KICK_IN_L_KW
%token	<ival>	KICK_IN_R_KW
%token	<ival>	FREE_KICK_L_KW
%token	<ival>	FREE_KICK_R_KW
%token	<ival>	CORNER_KICK_L_KW
%token	<ival>	CORNER_KICK_R_KW
%token	<ival>	GOAL_KICK_L_KW
%token	<ival>	GOAL_KICK_R_KW
%token	<ival>	GOAL_L_KW
%token	<ival>	GOAL_R_KW
%token	<ival>	DROP_BALL_KW
%token	<ival>	OFFSIDE_L_KW
%token	<ival>	OFFSIDE_R_KW
%token	<ival>	PENALTY_KICK_L_KW
%token	<ival>	PENALTY_KICK_R_KW
%token	<ival>	FIRST_HALF_OVER_KW
%token	<ival>	PAUSE_KW
%token	<ival>	HUMAN_JUDGE_KW
%token	<ival>	FOUL_CHARGE_L_KW
%token	<ival>	FOUL_CHARGE_R_KW
%token	<ival>	FOUL_PUSH_L_KW
%token	<ival>	FOUL_PUSH_R_KW
%token	<ival>	FOUL_MULTIPLE_ATTACK_L_KW
%token	<ival>	FOUL_MULTIPLE_ATTACK_R_KW
%token	<ival>	FOUL_BALLOUT_L_KW
%token	<ival>	FOUL_BALLOUT_R_KW

%type 	<ival> 		chg_view_count
%type 	<ival> 		move_count
%type 	<ival> 		catch_count
%type 	<ival> 		turn_neck_count
%type 	<ival> 		say_count
%type 	<ival> 		turn_count
%type 	<ival> 		dash_count
%type 	<ival> 		kick_count
%type	<view_mode_p>	view_mode
%type	<view_qual>	view_quality
%type	<view_wid>	view_width
%type 	<rval_arr>	stamina
%type 	<angle_p>	head_angle
%type	<vector2d_p>	speed

%type 	<sence_body_p>		sense_body
%type  	<server_param_p>	server_param
%type 	<player_param_p>	player_param
%type	<player_type_p>		player_type

%type	<location>	location
%type	<location>	line_name
%type	<line_p>	line

%type	<ival>		flag_location
%type	<ival>		flag_name
%type	<flag_p>	flag

%type	<ival>		ball_name
%type	<ball_p>	ball

%type 	<player_name_p>	player_name
%type	<player_p>	player
	
%type	<object_p>	object
%type	<object_pool_p>	object_pool

%type	<object_pool_p>	see

%type	<ival>		sensor_data

%token	<ival>		INIT_KW
%type	<side>		side
%type	<init_msg_p>	init

%token	<ival>		HEAR_KW
%token	<ival>		REF_KW
%token	<ival>		SELF_KW
%token	<side_p>	COACH_KW
%type	<ref_audio_p>	ref_audio
%type	<self_audio_p>	self_audio
%type	<player_audio_p>player_audio
%type	<coach_audio_p>	coach_audio

%token	<ival>		SCORE_KW
%type	<score_p>	score

/***************/
/* COACH STUFF */
/***************/
%token <ival> LB "{"
%token <ival> RB "}"

%token <ival> META
%token <ival> FREEFORM
%token <ival> INFO
%token <ival> ADVICE
%token <ival> DEFINE
%token <ival> DEFINEC
%token <ival> DEFINED
%token <ival> DEFINER
%token <ival> DEFINEA
/* meta stuff */
%token <ival> VER
/* region stuff */
%token <ival> NULL_REGION
%token <ival> QUAD
%token <ival> ARC
%token <ival> PT
%token <ival> REG
/* action stuff */
%token <ival> POS
%token <ival> HOME
%token <ival> BALLTO
%token <ival> MARK
%token <ival> MARK_LINE
%token <ival> OFFLINE
%token <ival> HTYPE
%type <ball_move> BMOVE_TOKEN
/* directive stuff */
%token <bval> DO_DONT
%token <side_p> TEAM
/* condition stuff */
%token <ival> TRUE_KW
%token <ival> FALSE_KW
%token <ival> PPOS
%token <ival> BPOS
%token <ival> BOWNER
%token <ival> AND
%token <ival> OR
%token <ival> NOT
%token <ival> PLAY_M_KW
%token <ival> CLEAR
%type <coach_std_msg_p> meta_mess
%type <coach_std_msg_p> freeform_mess
%type <coach_std_msg_p> info_mess
%type <coach_std_msg_p> advice_mess
%type <coach_std_msg_p> define_mess
%type <coach_meta_token_p> meta_token
%type <coach_meta_token_list_p> meta_token_list
%type <coach_define_token_p> define_token
%type <coach_define_token_list_p> define_token_list
/* region stuff */
%type <region_p> region
%type <reg_point_p> point
%type <reg_union_p> region_list
%type <unum_set_p> unum_set
%type <unum_set_p> unum_list
%type <ball_move_set_p> bmove_token_set
%type <ball_move_set_p> bmove_token_list

%type <action_p> action
%type <directive_p> directive
%type <dir_list_p> directive_list
%type <condition_p> condition
%type <cond_list_p> condition_list
%type <coach_info_token_p> token
%type <coach_info_token_list_p> token_list
/*******************/
/* END COACH STUFF */
/*******************/

%token	<ival>		CHANGE_KW
%type	<sub_p>		sub

%token	<ival>		BALL_KW

%start sensor_data

%%

/* Grammer */

/*(sense_body 0 (view_mode high normal) (stamina 4000 1) (speed 0 0) (head_angle 0) (kick 0) (dash 0) (turn 0) (say 0) (turn_neck 0) (catch 0) (move 0) (change_view 0))*/
VAL:		IVAL { $$ = (double)$1; }
| 	RVAL { $$ = $1; }

chg_view_count:	LP CHG_VIEW_KW IVAL RP { $$ = $3; }
move_count:	LP MOVE_KW IVAL RP { $$ = $3; }
catch_count:	LP CATCH_KW IVAL RP { $$ = $3; }
turn_neck_count:LP TURN_NECK_KW IVAL RP { $$ = $3; }
say_count:	LP SAY_KW IVAL RP { $$ = $3; }
turn_count:	LP TURN_KW IVAL RP { $$ = $3; }
dash_count:	LP DASH_KW IVAL RP { $$ = $3; }
kick_count:	LP KICK_KW IVAL RP { $$ = $3; }
view_mode:	LP VIEW_MODE_KW view_quality view_width RP { $$ = new RCC_ViewMode ( $3, $4 ); GC.add ( $$ ); }    
stamina:	LP STAMINA_KW VAL VAL RP { $$ = new double[2]; $$[0] = $3; $$[1] = $4; GC.add ( $$ ); }
head_angle:	LP HEAD_ANGLE_KW VAL RP { $$ = new RCC_Angle ( $3, RCC_Angle::DEG ); GC.add ( $$ ); }
speed:		LP SPEED_KW VAL VAL RP { $$ = new RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ); GC.add ( $$ ); } 
view_quality:	HIGH_KW { $$ = RCC_ViewMode::HIGH; } 
	| 	LOW_KW { $$ = RCC_ViewMode::LOW; }
view_width:	NARROW_KW { $$ = RCC_ViewMode::NARROW; }
	| 	NORMAL_KW { $$ = RCC_ViewMode::NORMAL; }
	| 	WIDE_KW { $$ = RCC_ViewMode::WIDE; }

sense_body:	LP SENSE_BODY_KW IVAL view_mode stamina speed head_angle kick_count dash_count turn_count
		say_count turn_neck_count catch_count move_count 
		chg_view_count RP 
		{ 
		    $$ = new RCC_SenceBody ( $3, *$4, $5[0], $5[1], *$6, *$7, $8, $9, $10, $11, $12, $13, $14, $15 );
		GC.add ( $$ );	
		GC.remDel ( $4 );	
		GC.remDel ( $5 );	
		GC.remDel ( $6 );	
		GC.remDel ( $7 );	
		}


/* (server_param 14.02 5 0.3 0.4 0.1 60 1 1 4000 45 0 0.3 0.5 0.002 0 0.3 0.6 0.005 0.6 0.01 0 0 1 1 1 1 0.085 0.94 0.05 0.2 2.7 2.7 0.006 0.027 0.7 2 1.7 100 -100 180 -180 180 -180 90 -90 90 3 0 0 0 0 1.085 2 1 1 2 1 5 0 0 128 128 300 1 1 1 1 50 1 3000 100 150 10 100 300 512 2 1 2 5 1 1 1 9.15 50 0.1 0.01 -1 -1 -1 -1 -1 -1 -1 0 0 0 100 0 0 0 0 200 ) */

server_param:	LP SERVER_PARAM_KW VAL VAL VAL VAL VAL VAL VAL VAL /*10*/
		VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL  /*20*/ 
		VAL VAL VAL IVAL VAL VAL VAL VAL VAL VAL /*30*/ 
		VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL	 /*40*/ 
		VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL  /*50*/ 
		VAL VAL VAL VAL VAL VAL VAL IVAL VAL VAL /*60*/ 
		IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL /*70*/ 
		IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL IVAL  /*80*/ 
		IVAL IVAL IVAL IVAL IVAL VAL VAL VAL VAL VAL  /*90*/ 
		VAL VAL VAL VAL VAL VAL IVAL IVAL IVAL IVAL  /*100*/ 
		IVAL IVAL IVAL IVAL IVAL RP
		{
		    $$ = new RCC_ServerParam ( $3, $4, $5, $6, $7, $8, $9, $10,
		$11, $12, $13, $14, $15, $16, $17, $18, $19, $20, 
		$21, $22, $23, $24, $25, $26, $27, $28, $29, $30, 
		$31, $32, $33, $34, $35, $36, $37, $38, $39, $40, 
		$41, $42, $43, $44, $45, $46, $47, RCC_Angle( $48, RCC_Angle::DEG ), $49, RCC_Angle( $50, RCC_Angle::DEG ), 
		$51, $52, $53, $54, $55, $56, $57, $58, $59, $60, 
		$61, $62, $63, $64, $65, $66, $67, $68, $69, $70, 
		$71, $72, $73, $74, $75, $76, $77, $78, $79, $80, 
		$81, $82, $83, $84, $85, $86, $87, $88, $89, $90, 
		$91, $92, $93, $94, $95, $96, $97, $98, $99, $100, 
		$101, $102, $103, $104, $105 );
		GC.add ( $$ );	
		} 

/* (player_param 7 3 3 0 0.2 -100 0 0.2 25 0 0.002 -100 0 0.2 0.5 0 100 -0.002 -0.002) */

player_param:	LP PLAYER_PARAM_KW IVAL IVAL IVAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL RP
		{
		$$ = new RCC_PlayerParam ( $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21 );
		GC.add ( $$ );	
		}

/* (player_type 0 1 45 0.4 5 0.006 0.3 0.7 0 0 1 0.6) */

player_type:	LP PLAYER_TYPE_KW IVAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL VAL RP
		{
		$$ = new RCC_PlayerType ( $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14 );
		GC.add ( $$ );	
		}

/* (see 0 ((g r) 54.1 -11) ((f r t) 68.7 -40) ((f r b) 58.6 24) ((f p r t) 47.5 -39) ((f p r c) 38.1 -15) ((f p r b) 38.1 16 -0 0) ((f g r t) 55.7 -18) ((f g r b) 53 -3) ((f t r 50) 70.1 -44) ((f b r 30) 42.1 43) ((f b r 40) 49.9 36) ((f b r 50) 58.6 30) ((f r t 30) 70.8 -35) ((f r t 20) 65.4 -27) ((f r t 10) 61.6 -19) ((f r 0) 59.1 -10) ((f r b 10) 58 0) ((f r b 20) 59.1 10) ((f r b 30) 61.6 19) ((l r) 53 -90)) */

location:	T_KW { $$ = RCC_Object::TOP_LOC; } 
	| 	B_KW { $$ = RCC_Object::BOTTOM_LOC; } 
	| 	L_KW { $$ = RCC_Object::LEFT_LOC; }
	| 	R_KW { $$ = RCC_Object::RIGHT_LOC; }
	| 	C_KW { $$ = RCC_Object::CENTER_LOC; }
	| 	P_KW { $$ = RCC_Object::PENALTY_LOC; }
	| 	G_KW { $$ = RCC_Object::GOAL_LOC; }

line_name:	LP L_KW location RP { $$ = $3; }

flag_location:	location { $$ = RCC_Flag::getNum ( $1 ); }
	| 	location location { $$ = RCC_Flag::getNum ( $1, $2 ); }
	| 	location IVAL { $$ = RCC_Flag::getNum ( $1, $2 ); }
	| 	location location IVAL { $$ = RCC_Flag::getNum ( $1, $2, $3 ); }
	| 	location location location { $$ = RCC_Flag::getNum ( $1, $2, $3 ); }

flag_name:	LP F_KW flag_location RP { $$ = $3; } 
	| 	LP G_KW location RP { $$ = RCC_Flag::getNum ( RCC_Object::GOAL_LOC, $3 ); }
	| 	LP F_KW RP { $$ = RCC_Flag::getNum (); }

line:		LP line_name VAL VAL RP { $$ = new RCC_Line ( $2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ) ); GC.add ( $$ ); }
	| 	LP line_name VAL RP { $$ = new RCC_Line ( $2, RCC_Angle ( $3, RCC_Angle::DEG ) ); GC.add ( $$ ); }

flag:		LP flag_name VAL VAL VAL VAL RP 
		{ $$ = new RCC_Flag ( $2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ), RCC_Vector2d ( $5, RCC_Angle ( $6, RCC_Angle::DEG ) ) ); GC.add ( $$ ); }
	| 	LP flag_name VAL VAL RP { $$ = new RCC_Flag ( $2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ) ); GC.add ( $$ ); }
	| 	LP flag_name VAL RP { $$ = new RCC_Flag ( $2, RCC_Angle ( $3, RCC_Angle::DEG ) ); GC.add ( $$ ); }

ball_name:	LP B_KW RP
		
ball:		LP ball_name VAL VAL VAL VAL RP 
		{ 
		$$ = new RCC_Ball ( RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ), RCC_Vector2d ( $5, RCC_Angle ( $6, RCC_Angle::DEG ) ) );
		GC.add ( $$ );
		}
	| 	LP ball_name VAL VAL RP { $$ = new RCC_Ball ( RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ) ); GC.add ( $$ ); }
	| 	LP ball_name VAL RP { $$ = new RCC_Ball ( RCC_Angle ( $3, RCC_Angle::DEG ) ); GC.add ( $$ ); }

player_name:	LP P_KW RP { $$ = new RCC_PlayerName (); GC.add ( $$ ); }
	| 	LP P_KW QSTR RP { $$ = new RCC_PlayerName ( string ( $3 ) ); GC.add ( $$ ); }
	| 	LP P_KW QSTR IVAL RP { $$ = new RCC_PlayerName ( string ( $3 ), $4 ); GC.add ( $$ ); }
	| 	LP P_KW QSTR IVAL GOALIE_KW RP { $$ = new RCC_PlayerName ( string ( $3 ), $4, true ); GC.add ( $$ );}

player:		LP player_name VAL VAL VAL VAL VAL VAL RP 
		{ 
		$$ = new RCC_Player ( *$2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ), RCC_Vector2d ( $5, RCC_Angle ( $6, RCC_Angle::DEG ) ), RCC_Angle ( $7, RCC_Angle::DEG ), RCC_Angle ( $8, RCC_Angle::DEG ) );
		GC.remDel ( $2 );	 
		GC.add ( $$ );
		}
	| 	LP player_name VAL VAL VAL VAL RP 
		{ 
		$$ = new RCC_Player ( *$2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ), RCC_Vector2d ( $5, RCC_Angle ( $6, RCC_Angle::DEG ) ) ); 
		GC.remDel ( $2 );
		GC.add ( $$ );
		}
	| 	LP player_name VAL VAL RP 
		{ 
		$$ = new RCC_Player ( *$2, RCC_Vector2d ( $3, RCC_Angle ( $4, RCC_Angle::DEG ) ) ); 
		GC.remDel ( $2 );
		GC.add ( $$ );
		}
	| 	LP player_name VAL RP 
		{ 
		$$ = new RCC_Player ( *$2, RCC_Angle ( $3, RCC_Angle::DEG ) ); 
		GC.remDel ( $2 );
		GC.add ( $$ );
		}


object:		line { $$ = ( RCC_Object* ) $1; }
	| 	flag { $$ = ( RCC_Object* ) $1; }
	| 	ball { $$ = ( RCC_Object* ) $1; }
	| 	player { $$ = ( RCC_Object* ) $1; }

object_pool:		/*nothing */ { $$ = new RCC_ObjectPool ( TN ); GC.add ( $$ ); }
	| 	object_pool object { $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }

see:		LP SEE_KW IVAL object_pool RP { $4->time ( $3 ); $$ = $4; }

		/* (init l 2 before_kick_off) */

side:		L_KW { $$ = LEFT; }
	| 	R_KW { $$ = RIGHT; }

init:		LP INIT_KW side IVAL PLAY_MODE_KW RP { $$ = new RCC_InitMsg ( $3, $4, *$5 ); GC.remDel ( $5 ); GC.add ( $$ ); }



		/* (hear 0 referee kick_off_l) */

ref_audio:	LP HEAR_KW IVAL REF_KW PLAY_MODE_KW RP { $$ = new RCC_RefAudio ( $3, *$5 ); GC.remDel ( $5 ); GC.add ( $$ ); }
	|	LP HEAR_KW IVAL REF_KW PLAY_MODE_KW IVAL RP { $$ = new RCC_RefAudio ( $3, *$5, $6 ); GC.remDel ( $5 ); GC.add ( $$ ); }
self_audio:	LP HEAR_KW IVAL SELF_KW QSTR RP { $$ = new RCC_SelfAudio ( $3, $5 ); GC.add ( $$ ); }

player_audio:	LP HEAR_KW IVAL VAL QSTR RP { $$ = new RCC_PlayerAudio ( $3, RCC_Angle ( $4, RCC_Angle::DEG ), $5 ); GC.add ( $$ ); }

		/* meta messages */
meta_mess:	LP META meta_token_list RP 
		{ $$ = new RCC_CoachMetaMsg ( *$3 ); GC.remDel ( $3 ); GC.add ( $$ ); }
                      
meta_token_list:meta_token_list meta_token
		{ $1->add ( $2 ); GC.remDel ( $2 ); $$ = $1; }
	| 	meta_token 
		{ $$ = new RCC_CoachMetaToken_List(); GC.add ( $$ ); $$->add ( $1 );
		GC.remDel ( $1 ); }

meta_token:	LP VER IVAL RP { $$ = new RCC_CoachMetaToken_Version ( $3 ); GC.add ( $$ ); } 

/* define messages */
define_mess:	LP DEFINE define_token_list RP 
		{ $$ = new RCC_CoachDefineMsg ( *$3 ); GC.remDel ( $3 ); 
		GC.add ( $$ ); }

define_token_list:
		define_token_list define_token 
		{ $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }
	| 	define_token 
		{ $$ = new RCC_CoachDefineToken_List(); GC.add ( $$ ); $$->add ( $1 ); 
		GC.remDel ( $1 ); }

define_token:	LP DEFINEC QSTR condition RP 
		{ $$ = new RCC_CoachDefineToken_Condition ( $3, $4 );
		GC.add ( $$ ); GC.remDel ( $4 ); }
	| 	LP DEFINED QSTR directive RP
		{ $$ = new RCC_CoachDefineToken_Directive ( $3, $4 ); 
		GC.add ( $$ ); GC.remDel ( $4 ); }
	| 	LP DEFINER QSTR region RP
		{ $$ = new RCC_CoachDefineToken_Region ( $3, $4 ); 
		GC.add ( $$ ); GC.remDel ( $4 ); }
	| 	LP DEFINEA QSTR action RP
		{ $$ = new RCC_CoachDefineToken_Action ( $3, $4 ); 
		GC.add ( $$ ); GC.remDel ( $4 ); }

/* freeform messages */
freeform_mess:	LP FREEFORM QSTR RP { $$ = new RCC_CoachFreeformMsg ( $3 ); GC.add ( $$ ); }

info_mess:	LP INFO token_list RP 
		{ $$ = new RCC_CoachInfoMsg ( *$3 ); GC.add ( $$ );
		GC.remDel ( $3 ); }

advice_mess:	LP ADVICE token_list RP 
		{ $$ = new RCC_CoachAdviceMsg ( *$3 ); 
		GC.add ( $$ ); GC.remDel ( $3 ); }

token:		LP IVAL condition directive_list RP 
		{ $$ = new RCC_CoachInfoToken_Rule ( $2, $3, *$4 );   
		GC.add ( $$ ); GC.remDel ( $3 ); GC.remDel ( $4 ); }
	| 	LP CLEAR RP { $$ = new RCC_CoachInfoToken_Clear(); GC.add ( $$ ); }

token_list:	token_list token 
		{ $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }
	| 	token 
		{ $$ = new RCC_CoachInfoToken_List (); $$->add ( $1 ); 
		GC.add ( $$ ); GC.remDel ( $1 ); }

action:		LP POS region RP                 
		{ $$ = new RCC_ActPosition ( $3 ); GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP HOME region RP                
		{ $$ = new RCC_ActHome ( $3 ); GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP BALLTO region bmove_token_set RP 
		{ $$ = new RCC_ActBallToRegion ($3, *$4 ); GC.add ( $$ ); 
		GC.remDel ( $3 ); GC.remDel ( $4 ); }
	| 	LP BALLTO unum_set RP            
		{ $$ = new RCC_ActBallToPlayer ( *$3 ); GC.add ( $$ ); GC.remDel( $3 ); }
	| 	LP MARK IVAL RP                   
		{ $$ = new RCC_ActMark ( $3 ); GC.add ( $$ ); }
	| 	LP MARK_LINE IVAL RP                   
		{ $$ = new RCC_ActMarkLinePlayer ( $3 ); GC.add ( $$ ); }
	| 	LP MARK_LINE region RP
		{ $$ = new RCC_ActMarkLineRegion ( $3 ); GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP OFFLINE region RP             
		{ $$ = new RCC_ActOffsidesLine ( $3 ); GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP HTYPE IVAL RP
		{ $$ = new RCC_ActHetType ( $3 ); GC.add ( $$ ); }
	| 	QSTR { $$ = new RCC_ActNamed ( $1 ); GC.add ( $$ ); }

directive:	LP DO_DONT TEAM unum_set action RP 
		{ $$ = new RCC_DirCommand ( $2, *$3, *$4, *$5);  
		GC.add ( $$ ); GC.remDel ( $3 ); GC.remDel ( $4 ); GC.remDel ( $5 ); }
	| 	QSTR { $$ = new RCC_DirNamed ( $1 ); GC.add ( $$ ); }

directive_list:	directive_list directive 
		{ $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }
	| 	directive 
		{ $$ = new RCC_DirList (); GC.add ( $$ ); $$->add($1); 
		GC.remDel ( $1 ); }

condition:	LP TRUE_KW RP                      
		{ $$ = new RCC_CondTrue(); GC.add ( $$ ); }
	| 	LP FALSE_KW RP                     
		{ $$ = new RCC_CondFalse(); GC.add ( $$ ); }
	| 	LP PPOS TEAM unum_set IVAL IVAL region RP 
		{ $$ = new RCC_CondPlayerPosition ( *$3, *$4, $5, $6, *$7 );  
		GC.add ( $$ ); GC.remDel ( $4 ); GC.remDel ( $7 ); }
	| 	LP BPOS region RP               
		{ $$ = new RCC_CondBallPosition ( $3 ); 
		GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP BOWNER TEAM unum_set RP      
		{ $$ = new RCC_CondBallOwner ( *$3, *$4 );  
		GC.add ( $$ ); GC.remDel ( $4 ); GC.remDel ( $3 ); }
	| 	LP PLAY_M_KW PLAY_MODE_KW RP
		{ $$ = new RCC_CondPlayMode ( *$3 ); GC.remDel ( $3 );
		GC.add ( $$ ); }
	| 	LP AND condition_list RP        
		{ $$ = new RCC_CondAnd ( *$3 );  
		GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP OR condition_list RP         
		{ $$ = new RCC_CondOr ( *$3 );  
		GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	LP NOT condition RP             
		{ $$ = new RCC_CondNot ( $3 ); GC.add ( $$ ); GC.remDel ( $3 ); }
	| 	QSTR { $$ = new RCC_CondNamed ( $1 ); GC.add ( $$ ); }

condition_list:	condition_list condition 
		{ $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }
	| 	condition 
		{ $$ = new RCC_CondList (); $$->add ( $1 ); 
		GC.remDel ( $1 ); GC.add ( $$ ); }

region:		point { $$ = $1; }
	| 	LP NULL_REGION RP 
		{ $$ = new RCC_RegNull (); GC.add ( $$ ); }
	| 	LP QUAD point point point point RP 
		{ $$ = new RCC_RegQuad (*$3, *$4, *$5, *$6 ); GC.add ( $$ );
		GC.remDel ( ( RCC_Region* ) $3 ); GC.remDel ( ( RCC_Region* ) $4 );
		GC.remDel ( ( RCC_Region* ) $5 ); GC.remDel ( ( RCC_Region* ) $6 ); }
	| 	LP ARC point VAL VAL VAL VAL RP 
		{ $$ = new RCC_RegArc ( *$3, $4, $5, RCC_Angle ( $6, RCC_Angle::DEG ), RCC_Angle ( $7, RCC_Angle::DEG ) ); 
		GC.add ( $$ ); GC.remDel ( ( RCC_Region* ) $3 ); }
	| 	LP REG region_list RP 
		{ $$ = $3 }
	| 	QSTR { $$ = new RCC_RegNamed ( $1 ); GC.add ( $$ ); }

region_list:	region_list region 
		{ $1->add ( $2 ); $$ = $1; GC.remDel ( $2 ); }
	| 	region 
		{ $$ = new RCC_RegUnion (); $$->add ( $1 ); 
		GC.remDel ( $1 ); GC.add ( $$ ); }

point:		LP PT VAL VAL RP { $$ = new RCC_RegAbsPoint ( $3, $4 ); GC.add ( ( RCC_Region* ) $$ ); }
	|	LP PT VAL VAL point RP { $$ = new RCC_RegRelPoint ( $3, $4, *$5 ); GC.remDel ( $5 ); GC.add ( ( RCC_Region* ) $$ ); }
	|	LP PT BALL_KW RP { $$ = new RCC_RegBallPoint (); GC.add ( ( RCC_Region* ) $$ ); }
	|	LP PT TEAM IVAL { $$ = new RCC_RegPlayerPoint ( *$3, $4 ); GC.add (  ( RCC_Region* ) $$ ); GC.remDel ( $3 ); }

unum_set:	LB unum_list RB { $$ = $2; }

unum_list:	/*empty*/ { $$ = new RCC_UnumSet(); GC.add ( $$ ); } 
	| 	unum_list IVAL { $$ = $1; $$->add ( $2 ); }

bmove_token_set:
		LB bmove_token_list RB { $$ = $2; }

bmove_token_list:
		bmove_token_list BMOVE_TOKEN 
		{ $$ = $1; $$->add ( $2 ); }
	| 	BMOVE_TOKEN 
		{ $$ = new RCC_BallMoveSet ( $1 ); GC.add ( $$ ); }

BMOVE_TOKEN:	P_KW { $$ = RCC_BallMoveSet::Pass; }
	|	D_KW { $$ = RCC_BallMoveSet::Dribble; }
	|	C_KW { $$ = RCC_BallMoveSet::Clear; }
	|	S_KW { $$ = RCC_BallMoveSet::Score; }

coach_audio:	LP HEAR_KW IVAL COACH_KW IVAL meta_mess RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5, $6 ); GC.remDel ( $4 ); GC.remDel ( $6 ); GC.add ( $$ ); }
	| 	LP HEAR_KW IVAL COACH_KW IVAL freeform_mess RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5, $6 ); GC.remDel ( $4 ); GC.remDel ( $6 ); GC.add ( $$ ); }
	| 	LP HEAR_KW IVAL COACH_KW IVAL info_mess RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5, $6 ); GC.remDel ( $4 ); GC.remDel ( $6 ); GC.add ( $$ ); }
	| 	LP HEAR_KW IVAL COACH_KW IVAL advice_mess RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5, $6 ); GC.remDel ( $4 ); GC.remDel ( $6 ); GC.add ( $$ ); }
	| 	LP HEAR_KW IVAL COACH_KW IVAL define_mess RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5, $6 ); GC.remDel ( $4 ); GC.remDel ( $6 ); GC.add ( $$ ); }
	|	LP HEAR_KW IVAL COACH_KW QSTR RP 
		{ $$ = new RCC_CoachAudio ( $3, *$4, $5 ); GC.add ( $$ ); }

score:		LP SCORE_KW IVAL IVAL IVAL RP
		{ $$ = new RCC_Score ( $3, $4, $5 ); GC.add ( $$ ); }		
	
sub:    	LP CHANGE_KW IVAL IVAL RP { $$ = new RCC_Substitution ( $3, $4 ); GC.add ( $$ ); }
	|	LP CHANGE_KW IVAL RP { $$ = new RCC_Substitution ( $3 ); GC.add ( $$ ); }


sensor_data:	sense_body { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	server_param { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	player_param { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	player_type { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	see { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	init { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	ref_audio { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	self_audio { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	player_audio { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	coach_audio { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	| 	score { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }
	|	sub { SD = RCC_SensorData ( *$1 ); GC.remDel ( $1 ); $$ = 0; }



%%

void yyerror (char* s)
{
    /*      fprintf (stderr, "%s: next token %d\n", s, yychar); */
    fprintf (stderr, "Error = %s\n", s);
}
