#include "rccplayerparam.h"

RCC_PlayerParam::RCC_PlayerParam ( const int& par_player_types,
			   const int& par_subs_max,
			   const int& par_pt_max,
  
			   const double& par_player_speed_max_delta_min,
			   const double& par_player_speed_max_delta_max,
			   const double& par_stamina_inc_max_delta_factor,
    
			   const double& par_player_decay_delta_min,
			   const double& par_player_decay_delta_max,
			   const double& par_inertia_moment_delta_factor,

			   const double& par_dash_power_rate_delta_min,
			   const double& par_dash_power_rate_delta_max,
			   const double& par_player_size_delta_factor,

			   const double& par_kickable_margin_delta_min,
			   const double& par_kickable_margin_delta_max,
			   const double& par_kick_rand_delta_factor,

			   const double& par_extra_stamina_delta_min,
			   const double& par_extra_stamina_delta_max,
			   const double& par_effort_max_delta_factor,
			   const double& par_effort_min_delta_factor )
    : player_types ( par_player_types ),
      subs_max ( par_subs_max ),
      pt_max ( par_pt_max ),
  
      player_speed_max_delta_min ( par_player_speed_max_delta_min ),
      player_speed_max_delta_max ( par_player_speed_max_delta_max ),
      stamina_inc_max_delta_factor ( par_stamina_inc_max_delta_factor ),
    
      player_decay_delta_min ( par_player_decay_delta_min ),
      player_decay_delta_max ( par_player_decay_delta_max ),
      inertia_moment_delta_factor ( par_inertia_moment_delta_factor ),

      dash_power_rate_delta_min ( par_dash_power_rate_delta_min ),
      dash_power_rate_delta_max ( par_dash_power_rate_delta_max ),
      player_size_delta_factor ( par_player_size_delta_factor ),

      kickable_margin_delta_min ( par_kickable_margin_delta_min ),
      kickable_margin_delta_max ( par_kickable_margin_delta_max ),
      kick_rand_delta_factor ( par_kick_rand_delta_factor ),

      extra_stamina_delta_min ( par_extra_stamina_delta_min ),
      extra_stamina_delta_max ( par_extra_stamina_delta_max ),
      effort_max_delta_factor ( par_effort_max_delta_factor ),
      effort_min_delta_factor ( par_effort_min_delta_factor )
{
}

ostream& RCC_PlayerParam::print ( ostream& o ) const
{
  return o << "(player_param"
	   << " " << player_types
	   << " " << subs_max
	   << " " << pt_max
  
	   << " " << player_speed_max_delta_min
	   << " " << player_speed_max_delta_max
	   << " " << stamina_inc_max_delta_factor
    
	   << " " << player_decay_delta_min
	   << " " << player_decay_delta_max
	   << " " << inertia_moment_delta_factor

	   << " " << dash_power_rate_delta_min
	   << " " << dash_power_rate_delta_max
	   << " " << player_size_delta_factor

	   << " " << kickable_margin_delta_min
	   << " " << kickable_margin_delta_max
	   << " " << kick_rand_delta_factor

	   << " " << extra_stamina_delta_min
	   << " " << extra_stamina_delta_max
	   << " " << effort_max_delta_factor
	   << " " << effort_min_delta_factor
	   << ")";
}
