#include "rccplayertype.h"

const int RCC_PlayerType::UNKNOWN_ID = -1;

RCC_PlayerType::RCC_PlayerType ( const int& par_id,
			 const double& par_player_speed_max,
			 const double& par_stamina_inc_max,
			 const double& par_player_decay,
			 const double& par_inertia_moment,
			 const double& par_dash_power_rate,
			 const double& par_player_size,
			 const double& par_kickable_margin,
			 const double& par_kick_rand,
			 const double& par_extra_stamina,
			 const double& par_effort_max,
			 const double& par_effort_min )
    : id ( par_id ),
      player_speed_max ( par_player_speed_max  ),
      stamina_inc_max ( par_stamina_inc_max ),
      player_decay ( par_player_decay ),
      inertia_moment ( par_inertia_moment ),
      dash_power_rate ( par_dash_power_rate ),
      player_size ( par_player_size ),
      kickable_margin ( par_kickable_margin ),
      kick_rand ( par_kick_rand ),
      extra_stamina ( par_extra_stamina ),
      effort_max ( par_effort_max ),
      effort_min ( par_effort_min )
{
}

ostream& RCC_PlayerType::print ( ostream& o ) const 
{ 
  return o << "(player_type"
	   << " " << id
	   << " " << player_speed_max
	   << " " << stamina_inc_max
	   << " " << player_decay
	   << " " << inertia_moment
	   << " " << dash_power_rate
	   << " " << player_size
	   << " " << kickable_margin
	   << " " << kick_rand
	   << " " << extra_stamina
	   << " " << effort_max
	   << " " << effort_min
	   << ")";
}
