#include "rccsencebody.h"

RCC_SenceBody::RCC_SenceBody(  const int& time, 
			       const RCC_ViewMode& vm, 
			       const double& stam, 
			       const double &eff, 
			       const RCC_Vector2d& v, 
			       const RCC_Angle& ha,
			       const int& kick_c, 
			       const int& dash_c, 
			       const int& turn_c, 
			       const int& say_c,
			       const int& turn_neck_c, 
			       const int& catch_c, 
			       const int& move_c, 
			       const int& chg_view_c )
  : bi_time ( time ), 
  view_mode ( vm ), 
  stamina_ ( stam ), 
  effort_ ( eff ), 
  velocity ( v ), 
  head_angle ( ha ), 
  kick_count ( kick_c ), 
  dash_count ( dash_c ), 
  turn_count ( turn_c ),
  say_count ( say_c ), 
  turn_neck_count ( turn_neck_c ), 
  catch_count ( catch_c ), 
  move_count ( move_c ), 
  change_view_count ( chg_view_c )
{	
}

RCC_SenceBody::~RCC_SenceBody()
{

}

ostream& RCC_SenceBody::print (ostream& o,  RCC_Vector2d::mode_t vm, RCC_Angle::mode_t am ) const
{
  return o << "(sense_body " << bi_time << " "
	   << "(view_mode " << view_mode << ") "
	   << "(stamina " << stamina_ << " " << effort_ << ") "
	   << "(speed " << velocity << ") "
	   << "(head_angle " << head_angle << ") "
	   << "(kick " << kick_count << ") "
	   << "(dash " << dash_count << ") "
	   << "(turn " << turn_count << ") "
	   << "(say " << say_count << ") "
	   << "(turn_neck " << turn_neck_count << ") "
	   << "(catch " << catch_count << ") "
	   << "(move " << move_count << ") "
	   << "(change_view " << change_view_count << "))";
}
