#include "rccserverparam.h"

RCC_ServerParam::RCC_ServerParam ( const double& par_gwidth, 
				   const double& par_inertia_moment, 
				   const double& par_psize, 
				   const double& par_pdecay, 
				   const double& par_prand,
				   const double& par_pweight, 
				   const double& par_pspeed_max, 
				   const double& par_paccel_max, 
				   const double& par_stamina_max, 
				   const double& par_stamina_inc,
				   const double& par_recover_init, 
				   const double& par_recover_dthr, 
				   const double& par_recover_min, 
				   const double& par_recover_dec, 
				   const double& par_effort_init,
				   const double& par_effort_dthr, 
				   const double& par_effort_min, 
				   const double& par_effort_dec, 
				   const double& par_effort_ithr, 
				   const double& par_effort_inc,
				   const double& par_kick_rand, 
				   const int& par_team_actuator_noise, 
				   const double& par_prand_factor_l, 
				   const double& par_prand_factor_r, 
				   const double& par_kick_rand_factor_l,
				   const double& par_kick_rand_factor_r, 
				   const double& par_bsize, 
				   const double& par_bdecay, 
				   const double& par_brand , 
				   const double& par_bweight,
				   const double& par_bspeed_max, 
				   const double& par_baccel_max, 
				   const double& par_dprate, 
				   const double& par_kprate, 
				   const double& par_kmargin,
				   const double& par_ctlradius, 
				   const double& par_ctlradius_width, 
				   const double& par_maxp, 
				   const double& par_minp, 
				   const double& par_maxm,
				   const double& par_minm, 
				   const double& par_maxnm, 
				   const double& par_minnm, 
				   const double& par_maxn, 
				   const double& par_minn,
				   RCC_Angle par_visangle, 
				   const double& par_visdist, 
				   RCC_Angle par_windir, 
				   const double& par_winforce, 
				   const double& par_winang,
				   const double& par_winrand, 
				   const double& par_kickable_area, 
				   const double& par_catch_area_l, 
				   const double& par_catch_area_w, 
				   const double& par_catch_prob,
				   const int& par_goalie_max_moves, 
				   const double& par_ckmargin, 
				   const double& par_offside_area, 
				   const int& par_win_no, 
				   const int& par_win_random,
				   const int& par_say_cnt_max, 
				   const int& par_SayCoachMsgSize, 
				   const int& par_clang_win_size, 
				   const int& par_clang_define_win, 
				   const int& par_clang_meta_win,
				   const int& par_clang_advice_win, 
				   const int& par_clang_info_win, 
				   const int& par_clang_mess_delay, 
				   const int& par_clang_mess_per_cycle, 
				   const int& par_half_time,
				   const int& par_sim_st, 
				   const int& par_send_st, 
				   const int& par_recv_st, 
				   const int& par_sb_step, 
				   const int& par_lcm_st,
				   const int& par_SayMsgSize, 
				   const int& par_hear_max, 
				   const int& par_hear_inc, 
				   const int& par_hear_decay, 
				   const int& par_cban_cycle,
				   const int& par_slow_down_factor, 
				   const int& par_useoffside, 
				   const int& par_kickoffoffside, 
				   const double& par_offside_kick_margin, 
				   const double& par_audio_dist,
				   const double& par_dist_qstep, 
				   const double& par_land_qstep, 
				   const double& par_dir_qstep, 
				   const double& par_dist_qstep_l, 
				   const double& par_dist_qstep_r, 
				   const double& par_land_qstep_l, 
				   const double& par_land_qstep_r, 
				   const double& par_dir_qstep_l, 
				   const double& par_dir_qstep_r, 
				   const int& par_CoachMode,
				   const int& par_CwRMode, 
				   const int& par_old_hear, 
				   const int& par_sv_st, 
				   const int& par_start_goal_l, 
				   const int& par_start_goal_r,
				   const int& par_fullstate_l, 
				   const int& par_fullstate_r, 
				   const int& par_drop_time)
  : gwidth ( par_gwidth ), 
  inertia_moment ( par_inertia_moment ), 
  psize ( par_psize ), 
  pdecay ( par_pdecay ), 
  prand ( par_prand ),
  pweight ( par_pweight ), 
  pspeed_max ( par_pspeed_max ), 
  paccel_max ( par_paccel_max ), 
  stamina_max ( par_stamina_max ), 
  stamina_inc ( par_stamina_inc ),
  recover_init ( par_recover_init ), 
  recover_dthr ( par_recover_dthr ), 
  recover_min ( par_recover_min ), 
  recover_dec ( par_recover_dec ), 
  effort_init ( par_effort_init ),
  effort_dthr ( par_effort_dthr ), 
  effort_min ( par_effort_min ), 
  effort_dec ( par_effort_dec ) , 
  effort_ithr ( par_effort_ithr ), 
  effort_inc ( par_effort_inc ),
  kick_rand ( par_kick_rand ), 
  team_actuator_noise ( par_team_actuator_noise ), 
  prand_factor_l ( par_prand_factor_l ), 
  prand_factor_r ( par_prand_factor_r ), 
  kick_rand_factor_l ( par_kick_rand_factor_l ),
  kick_rand_factor_r ( par_kick_rand_factor_r ), 
  bsize ( par_bsize ), 
  bdecay ( par_bdecay ), 
  brand ( par_brand ), 
  bweight ( par_bweight ),
  bspeed_max ( par_bspeed_max ), 
  baccel_max ( par_baccel_max ), 
  dprate ( par_dprate ), 
  kprate ( par_kprate ), 
  kmargin ( par_kmargin ),
  ctlradius ( par_ctlradius ), 
  ctlradius_width ( par_ctlradius_width ), 
  maxp ( par_maxp ), 
  minp ( par_minp ), 
  maxm ( par_maxm ),
  minm ( par_minm ), 
  maxnm ( par_maxnm ), 
  minnm ( par_minnm ), 
  maxn ( par_maxn ), 
  minn ( par_minn ),
  visangle ( par_visangle ), 
  visdist ( par_visdist ), 
  windir ( par_windir ), 
  winforce ( par_winforce ), 
  winang ( par_winang ),
  winrand ( par_winrand ), 
  kickable_area ( par_kickable_area ), 
  catch_area_l ( par_catch_area_l ), 
  catch_area_w ( par_catch_area_w ), 
  catch_prob ( par_catch_prob ),
  goalie_max_moves ( par_goalie_max_moves ), 
  ckmargin ( par_ckmargin ), 
  offside_area ( par_offside_area ), 
  win_no ( par_win_no ), 
  win_random ( par_win_random ),
  say_cnt_max ( par_say_cnt_max ), 
  SayCoachMsgSize ( par_SayCoachMsgSize ), 
  clang_win_size ( par_clang_win_size ), 
  clang_define_win ( par_clang_define_win ), 
  clang_meta_win ( par_clang_meta_win ),
  clang_advice_win ( par_clang_advice_win ), 
  clang_info_win ( par_clang_info_win ), 
  clang_mess_delay ( par_clang_mess_delay ), 
  clang_mess_per_cycle ( par_clang_mess_per_cycle ), 
  half_time ( par_half_time ),
  sim_st ( par_sim_st ), 
  send_st ( par_send_st ), 
  recv_st ( par_recv_st ), 
  sb_step ( par_sb_step ), 
  lcm_st ( par_lcm_st ),
  SayMsgSize ( par_SayMsgSize ), 
  hear_max ( par_hear_max ), 
  hear_inc ( par_hear_inc ), 
  hear_decay ( par_hear_decay ), 
  cban_cycle ( par_cban_cycle ),
  slow_down_factor ( par_slow_down_factor ), 
  useoffside ( par_useoffside ), 
  kickoffoffside ( par_kickoffoffside ), 
  offside_kick_margin ( par_offside_kick_margin ), 
  audio_dist ( par_audio_dist ),
  dist_qstep ( par_dist_qstep ), 
  land_qstep ( par_land_qstep ), 
  dir_qstep ( par_dir_qstep ), 
  dist_qstep_l ( par_dist_qstep_l ), 
  dist_qstep_r ( par_dist_qstep_r ),
  land_qstep_l ( par_land_qstep_l ), 
  land_qstep_r ( par_land_qstep_r ), 
  dir_qstep_l ( par_dir_qstep_l ), 
  dir_qstep_r ( par_dir_qstep_r ), 
  CoachMode ( par_CoachMode ),
  CwRMode ( par_CwRMode ), 
  old_hear ( par_old_hear ), 
  sv_st ( par_sv_st ), 
  start_goal_l ( par_start_goal_l ), 
  start_goal_r ( par_start_goal_r ),
  fullstate_l ( par_fullstate_l ), 
  fullstate_r ( par_fullstate_r ), 
  drop_time ( par_drop_time )
{
}


ostream& RCC_ServerParam::print ( ostream& o ) const
{
  return o
    << "(server_param" 
    << " " << gwidth 					
    << " " << inertia_moment 	
    << " " << psize 			
    << " " << pdecay 			
    << " " << prand 
			
    << " " << pweight 				
    << " " << pspeed_max 		
    << " " << paccel_max 		
    << " " << stamina_max 			
    << " " << stamina_inc 
			
    << " " << recover_init 		
    << " " << recover_dthr 		
    << " " << recover_min 			
    << " " << recover_dec 			
    << " " << effort_init 
			
    << " " << effort_dthr 			
    << " " << effort_min 		
    << " " << effort_dec 			
    << " " << effort_ithr 			
    << " " << effort_inc
 			
    << " " << kick_rand                             
    << " " << team_actuator_noise                     
    << " " << prand_factor_l                          
    << " " << prand_factor_r                            
    << " " << kick_rand_factor_l
                       
    << " " << kick_rand_factor_r                     
    << " " << bsize 			
    << " " << bdecay 			
    << " " << brand 			
    << " " << bweight
 				
    << " " << bspeed_max 			
    << " " << baccel_max 			
    << " " << dprate 			
    << " " << kprate 			
    << " " << kmargin
 				
    << " " << ctlradius 			
    << " " << ctlradius_width 		
    << " " << maxp				
    << " " << minp 				
    << " " << maxm
 				
    << " " << minm 				
    << " " << maxnm 				
    << " " << minnm 				
    << " " << maxn 				
    << " " << minn
 				
    << " " <<  visangle.deg () 			
    << " " << visdist 					
    << " " << windir.deg () 					
    << " " << winforce 				
    << " " << winang
 					
    << " " << winrand 					
    << " " << kickable_area 			
    << " " << catch_area_l 			
    << " " << catch_area_w 			
    << " " << catch_prob 
				
    << " " << goalie_max_moves                  	
    << " " << ckmargin 				
    << " " << offside_area 			
    << " " << win_no 					
    << " " << win_random 
				
    << " " << say_cnt_max 				
    << " " << SayCoachMsgSize 				
    << " " << clang_win_size
    << " " << clang_define_win
    << " " << clang_meta_win

    << " " << clang_advice_win
    << " " << clang_info_win
    << " " << clang_mess_delay
    << " " << clang_mess_per_cycle
    << " " << half_time
 					
    << " " << sim_st 					
    << " " << send_st 					
    << " " << recv_st 					
    << " " << sb_step 					
    << " " << lcm_st
 		                        
    << " " << SayMsgSize 				
    << " " << hear_max 					
    << " " << hear_inc 					
    << " " << hear_decay 				
    << " " << cban_cycle
 				
    << " " << slow_down_factor                           
    << " " << useoffside 				
    << " " << kickoffoffside 			
    << " " << offside_kick_margin 		
    << " " << audio_dist 
				
    << " " << dist_qstep 				
    << " " << land_qstep 				
    << " " << dir_qstep 				
    << " " << dist_qstep_l 			
    << " " << dist_qstep_r 
			
    << " " << land_qstep_l 			
    << " " << land_qstep_r 			
    << " " << dir_qstep_l 				
    << " " << dir_qstep_r 				
    << " " << CoachMode
 				
    << " " << CwRMode 					
    << " " << old_hear 					
    << " " << sv_st
    << " " << start_goal_l
    << " " << start_goal_r

    << " " << fullstate_l
    << " " << fullstate_r
    << " " << drop_time
    << " )";
}
