#include "rccviewmode.h"

const double RCC_ViewMode::WIDTH_MODIFIERS[] = { -1.0, 0.5, 1.0, 2.0 };	// the widths are used to modify ServerParams.visible_angle
const string RCC_ViewMode::WIDTH_NAMES[] = { "narrow", "normal", "wide" };
const string RCC_ViewMode::QUALITY_NAMES[] = { "high", "low" };

RCC_ViewMode::RCC_ViewMode ( const RCC_ViewMode::quality_t& q, const RCC_ViewMode::width_t& w ) 
  : qual ( q ), wid ( w )
{
}


RCC_ViewMode::~RCC_ViewMode ()
{
}


ostream& RCC_ViewMode::print ( ostream &o ) const
{
  o << qual << " " << wid;
  return o;
}

ostream& operator<< (ostream& o, const RCC_ViewMode::width_t& w) 
{ 
  o << RCC_ViewMode::WIDTH_NAMES [ w ]; 
  return o; 
}

ostream& operator<< (ostream& o, const RCC_ViewMode::quality_t& q) 
{ 
  o << RCC_ViewMode::QUALITY_NAMES [ q ]; 
  return o; 
}
